;;;   DLINKA.lsp
;;;   Copyright (C) 1990-92 Autodesk, Inc.
;;;  
;;;   Povolen k pouit, koprovn, modifikovn a roziovn tohoto 
;;;   programu a jeho dokumentace zdarma je tmto zaruena s tm e se
;;;   ve uveden copyright a tato informace objev ve vem pouitm
;;;   software a dokumentaci.
;;;
;;;   TENTO SOFTWARE JE K DISPOZICI BEZ VSLOVN NEBO VYPLVAJC ZRUKY.
;;;   TMTO JSOU ODMTNUTY JAKKOLIV ZRUKY NEBO POUIT PRO KONKRTN
;;;   PRODEJNOST A ELY.
;;; 
;;;   Jan S. Yoder
;;;   5. dubna 1990
;;;
;;;----------------------------------------------------------------------------
;;;   POPIS
;;;     
;;;     Toto je obecn genertor "dvojit linky/oblouku". Vykonv automatick 
;;;     napojen rohovch prsek a m adu jinch vlastnost popsanch
;;;     dle.
;;;  
;;;     Uivatel je vyzvn pro zadn ady koncovch bod. Po tomto zadn
;;;     jsou kresleny segmenty "dlinky" v aktuln hladin. Jsou k dispozici
;;;     rzn pomcky pro zmnu tlouky dlinky, uruj, zdali se bude provdt
;;;     uchopen k existujcm arm nebo obloukm, zdali se budou ry 
;;;     peruovat v oblastech uchopen a dle:
;;;     
;;;     Nastavit globln promnnou dl:ecp na hodnoty uveden dole:
;;;  
;;;     Hodnota  Vznam
;;;     ---------------------------
;;;       0    Bez koncovch epiek
;;;       1    epiky pouze na zatku
;;;       2    epiky pouze na konci
;;;       3    Ob koncov epice
;;;       4    Auto ANO -- Uzavi kad konec nelec na sece nebo oblouku
;;;       
;;;     Uivatel si me vybrat nvrat na zatek pkazu zapsnm "Z" nebo
;;;     "Zpt", piem kad z nich funguje jako AutoCADovsk "ZPT 1".
;;;     
;;;     Zakiven dvojit ry jsou kreslen pouitm AutoCADovskm pkazem
;;;     OBLOUK a sleduj co nejbl jejich pkazovou strukturu a jej volby.
;;;  
;;;----------------------------------------------------------------------------
;;;   INNOST
;;;
;;;     Tato rutina se spout, po naten, vypsnm bu DL nebo DLINKA;
;;;     v tomto okamiku se objev vodn menu s volbami:
;;;     
;;;       Dlinka, Version 1.00, (c) 1990 by Autodesk, Inc.  
;;;       Break/Caps/Dragline/Offset/Snap/Undo/Width/<start point>: 
;;;       Peru/epIka/Vle/Ekvid/Krok/Zpt/Tlouka/<poten bod>:
;;;     
;;;     Napsnm Peru mete zapnout i vypnout peruen seek a oblouk
;;;     nalezench v koncovch bodech segment.
;;;     
;;;       Peruit dvojit ry v potench a koncovch bodech?  NE/<ANO>:
;;;     
;;;     Napsnm epIce mete specifikovat zpsob, jakm bude DLINKA 
;;;     uzavena po ukonen funkce, podle ve uvedench hodnot.
;;;     
;;;       Nakreslit kter epice?  Ob/Koncovou/dnou/Poten/<Auto>:
;;;       
;;;     Implicitn hodnota z Auto uzavr konec ry jen pokud jste nekrokovali
;;;     oblouk nebo ru.
;;;     
;;;     Napsnm Vle mete nastavit umstn vlec, relativn ke stedov
;;;     e dvou oblouk nebo seek, v hodnot mezi -1/2 promnn
;;;     "tracewid" a +1/2 "tracewid". (Existuje lokln promnn, kterou
;;;     mete nastavit, pokud chcete experimentovat s posuvy mimo tento rozsah.
;;;     Vsledky pak nemus bt sprvn. Podvejte se
;;;     na funkci (dl_sao) pro vce informac.)
;;;     
;;;       Nastavte pozici vlec ry na Lev/Sted/Prav/<Ekvid. ze stedu = 0.0>:
;;;     
;;;     Zadejte jakoukoli relnou hodnotu nebo nkter z klovch slov.
;;;     Hodnota v lomench zvorkch je implicitn a mn se, jestlie se zmn
;;;     pozice pesouvac ry.
;;;     
;;;     Ekvid umouje posunout prvn bod, kter zadte, od njakho jinho
;;;     znamho bodu.
;;;     
;;;       Ekvid od:  (zadejte bod)
;;;       Ekvid  k:  (zadejte bod)
;;;       Zadejte vzdlenost Ekvid:   (zadejte vzdlenost nebo reln slo)
;;;  
;;;     Krok umouje nastavit velikost kroku a zapnout nebo vypnout
;;;     krokovn.
;;;     
;;;       Nastavte velikost kroku nebo krokovn Ano/Ne. Velikost/NE/<ANO>:
;;;       Nov velikost kroku (1 - 10):
;;;     
;;;     Horn mez me bt nastaven zmnou hodnoty MAXSNP na 
;;;     hodnotu jinou ne 10. Vy hodnoty mohou bt potebn pro ADI
;;;     ovladae obrazovky, ale obecn je poteba nastavit tuto hodnotu
;;;     nkde uprosted povolenho rozsahu, aby uchopovn pracovalo efektivn.
;;;     V pli zaplnnm vkresu je vhodnj ni hodnota.
;;;     
;;;     Tato vlastnost umouje velmi rychle "uchopit" do jinou seku nebo
;;;     oblouk, peruit ji v mst pipojen a provst veker oezvac 
;;;     itn bez nutnosti ukazovat pesn na ru nebo oblouk.
;;;     
;;;     Zpt vs vrac zptky o jeden segment v etzci segment kter
;;;     kreslte a kon, kdy u nejsou dn segmenty pro vracen. 
;;;     Vechny potebn body jsou uchovny v seznamech tak, e DLINKA se ukon,
;;;     uzave a pokrauje sprvn po jakmkoli potu zptnch nvrat.
;;;     
;;;     Tlouka nabz nastaven nov tlouky.
;;;     
;;;       Nov tlouka ry <1.0000>:
;;;       
;;;     Mete zadat novou tlouku a pokraovat v pkazu DLINKA ve stejnm
;;;     smru, ve kterm jste zaali kreslit; jestlie to udlte, spojovac
;;;     ry z konc pedchozho segmentu se kresl do potench bod novho 
;;;     segmentu.
;;;     
;;;     Pokud stisknete RETURN po ukonen pkazu DLINKA nebo ped
;;;     vytvoenm jakkoli ry, uvidte tuto zprvu:
;;;     
;;;       Neexistuje bod pro pokraovn -- prosm, vyberte bod.  
;;;       Peru/eoIce/Vle/Ekvid/Krok/Zpt/Tlouka/<poten bod>:
;;;
;;;     Po vybrn prvnho bodu uvidte tyto volby:
;;;     
;;;       Arc/Break/CAps/CLose/Dragline/Snap/Undo/Width/<next point>:
;;;       oBlouk/Peru/epIce/Uzavi/Vle/uChop/Zpt/Tlouka/<poten bod>:
;;;
;;;     Vybrn dalch bod bude kreslit pm dvojit segmenty, ne stisknete
;;;     RETURN nebo vyberete volbu Konec.
;;;     
;;;     Konec ukon ry, pokud jste nakreslili alespo dva segmenty.
;;;     
;;;     Volba Oblouk nabz novou sadu voleb:
;;;     
;;;       Peru/epIce/Centr/Uzavi/Vle/kOncov/USeka/uChop/Zpt/Tlouka/<druh bod>:
;;;
;;;     Vechny tyto volby jsou stejn jako pi kreslenm pmch dvojitch ar
;;;     s vjimkou Sted, Koncov a seka.
;;;     
;;;     Implicitn volba Sted a volba Koncov jsou modelovny podle pkazu OBLOUK
;;;     AutoCADu a pesn napodobuj jeho operace, vetn vech podvoleb.
;;;     Podvejte se do referennho manulu AutoCADu pro pesn pouit.
;;;     
;;;     Volba seka vs vrac do kreslen pmch dvojitch segment.
;;;     
;;;     Uchopovn existujcch seek i oblouk provd vechna potebn
;;;     oezn a prodluovn seek a oblouk, vetn ppad, kdy se oblouky a
;;;     seky neprotnaj. V tchto ppadech se seka kresl bu: bodem
;;;     na oblouku v mst kolmm na sted oblouku k sece, nebo podl 
;;;     seky ze sted obou oblouk, kter se neprotnaj v bodech, kde tato
;;;     seka protn oba oblouky. V tomto ppad zajistme, e vechny
;;;     d-linky mohou bt ukoneny vizuln.
;;;     
;;;     Peruovn seek nebude fungovat s vypnutm Krokem.
;;;-------------------------------------------------------------------------
;;;     
;;;  GLOBLN PROMNN:
;;;     dl:osd -- vzdlenost ekvidistant ze stedu dvou seek nebo
;;;               oblouk.
;;;     dl:snp -- T pokud krokuje existujc seky nebo oblouky.
;;;     dl:brk -- T pokud peruuje existujc seky a oblouky.
;;;     dl:ecp -- Bitov nastaven uzvr pi vstupu.
;;;     v:stpt -- Nvazn bod.
;;;

;;; ===================== natac chybov kontrola ============================
;;;

  (defun ai_abort (app msg)
     (defun *error* (s)
        (if old_error (setq *error* old_error))
        (princ)
     )
     (if msg
       (alert (strcat " Chyba aplikace: "
                      app
                      " \n\n  "
                      msg
                      "  \n"
              )
       )
     )
     (exit)
  )

;;; Kontroluje naten AI_UTILS, jestlie nen zkou jej nalzt a nast.
;;;
;;; Jestlie ji neme najt nebo nast potom okamit ukon natn souboru
;;; uchov (autonaten) zbytek funkce.

  (cond
     (  (and ai_dcl (listp ai_dcl)))          ; je naten

     (  (not (findfile "ai_utils.lsp"))                     ; hled
        (ai_abort "DLINE"
                  (strcat "Nemohu najt soubor AI_UTILS.LSP."
                          "\n Zkontrolujte adres SUPPORT.")))

     (  (eq "failed" (load "ai_utils" "failed"))            ; nat
        (ai_abort "DLINE" "Nemohu nast soubor AI_UTILS.LSP"))
  )

  (if (not (ai_acadapp))               ; definovno v AI_UTILS.LSP
      (ai_abort "DLINE" nil)         ; a Nil <msg> potla
  )                                    ; ai_abort vstran okno

;;; ==================== konec matac operace ===========================
;;;----------------------------------------------------------------------------
;;; Hlavn funkce

(defun dline  (/ strtpt nextpt pt1    pt2    spts   wnames elast
                 uctr   pr     prnum  temp   ans    dir    ipt
                 v      lst    dist   cpt    rad    orad   ftmp
                 spt    ept    pt     en1    en2    npt    cpt1
                 flg    cont   flg2   flgn   ang    tmp    undo_setting
                 brk_e1 brk_e2 bent1  bent2  nn     nnn    
                 dl_osm dl_oem dl_oce dl_opb dl_obm dl_ver 
                 dl_err dl_oer dl_arc fang   MAXSNP ange   
                 savpt1 savpt2 savpt3 savpt4 savpts 
              )

  ;; slo verze. Penastavuje se tato lokln promnn, pokud udlte zmnu.
  (setq dl_ver "1.11")  
  
  ;; Penastavuje tato hodnota na vy pro ADI ovladae.
  (setq MAXSNP 10)              

  (setq dl_osm (getvar "osmode")
        dl_oce (getvar "cmdecho")
        dl_opb (getvar "pickbox")
  )

  ;;
  ;; Vnitn chybov program definovan lokln
  ;;

  (defun dl_err (s)                   ; Pokud vznikne chyba (nap. CTRL-C), ne
                                      ; je tento pkaz aktivn...
    (if (/= s "Funkce zruena")
      (if (= s "quit / exit abort")
        (princ)
        (princ (strcat "\nChyba: " s))
      )
    )
    (command "_undo" "_end")
    (ai_undo_off)
    (if dl_oer                        ; Jestlie existuje star chybov rutina,
      (setq *error* dl_oer)           ; pak ji penastav 
    )
    (if dl_osm (setvar "osmode" dl_osm))
    (if dl_opb (setvar "pickbox" dl_opb))
    
    ;; Penastaven pkazu naznaujc chybu
    (if dl_oce (setvar "cmdecho" dl_oce))      
    (princ)
  )
  
  ;; Nastaven novho chybovho programu
  (if (not *DEBUG*)
    (if *error*
      (setq dl_oer *error* *error* dl_err)
      (setq *error* dl_err)
    )
  )

  (setvar "cmdecho" 0)
  (ai_undo_on)
  (command "_Undo" "_group")
  (setvar "osmode" 0)
  (if (null dl:opb) (setq dl:opb (getvar "pickbox")))

  (setq nextpt "Straight")
 
  ;; Bere prvn poten bod segmentu
 
  (menucmd "s=dline1")
  (graphscr)
  (princ (strcat "\nDlinka, Verze " dl_ver ", (c) 1990-1992 od Autodesk, Inc. "))
  
  (setq cont T)
  (while cont
    (dl_m1)
 
    ;; Pipraven kreslit postupn dvojit segmenty
 
    (dl_m2)
  )
  
  (if dl_osm (setvar "osmode" dl_osm))
  (if dl_opb (setvar "pickbox" dl_opb))

  (ai_undo_off)                   ;Vrt Undo do inicializovanho stavu

  ;; Reset command echoing
  (if dl_oce (setvar "cmdecho" dl_oce))      
  (menucmd "s=s")
  (princ)
)
;;;
;;; Podprogram 1. hlavnho programu.
;;;
;;; dl_m1 == DLine_Hlavn_1
;;;
(defun dl_m1 ()
  (setq temp T
        uctr nil 
  )
  (if dl_arc
    (setq nextpt "Arc")
    (setq nextpt "Line")
  )
  ;; temp nastavuje nulu, kdy se zad platn bod.
  (while temp
    (initget "Peru epIce Vle Ekvid Krok Zpt Tlouka")
    (setq strtpt (getpoint 
      "\nPeru/epIce/Vle/Ekvid/Krok/Zpt/Tlouka/<poten bod>: "))
    (cond
      ((= strtpt "Vle")
        (dl_sao)
      )
      ((= strtpt "Peru")
        (initget "ANO NE")
        (setq dl:brk (getkword 
          "\nPeruit ru v potench a koncovch bodech?  NE/<ANO>: "))
        (setq dl:brk (if (= dl:brk "NE") nil T))    
      )
      ((= strtpt "Ekvid")
        (dl_ofs)
      )
      ((= strtpt "Krok")
        (dl_sso)
      )
      ((= strtpt "Zpt")
        (princ "\nVechny segmenty jsou vrcen. ")
        (setq temp T)
      )
      ((= strtpt "Tlouka")
        (initget 6)
        (dl_snw)
        (setq temp T)
      )
      ((null strtpt)
        (if v:stpt
          (setq strtpt v:stpt
                temp   nil
          )
          (progn
            (princ "\nNeexistuje nvazn bod -- prosm vyberte bod. ")
          )
        )
      )
      ((= strtpt "epIce")
        (endcap)    
      )
      ;; Jestlie nic z ve uvedenho nevzbrno, zadat OK pro pokraovn - bod byl 
      ;; vybrn nebo zadn z klvesnice.
      (T
        (setq v:stpt strtpt
              temp   nil
        )
      )
    )
  )
)
;;;
;;; Podprogram 2. hlavnho programu.
;;;
;;; dl_m3 == DLine_Hlavn_2
;;;
(defun dl_m2 (/ temp)
  (setq spts (list strtpt)
        uctr 0 
  )
  (if dl:snp
    (dl_ved "brk_e1" strtpt)
  )
  ;; Pesvdete se, zda posunut nen vt ne 1/2 tlouky, i kdy
  ;; je uivatel nastavuje transparentn v prbhu pkazu.
  (setq temp (/ (getvar "tracewid") 2.0))
  (if (< dl:osd (- temp))
    (setq dl:osd (- temp))
  )
  (if (> dl:osd temp)
    (setq dl:osd temp)
  )
    
  (while (and nextpt (/= nextpt "Uzavi"))
    (if (/= nextpt "Ven")
      (if dl_arc 
        (progn
          (menucmd "s=dline2")
          (initget 
            "Peru epIce Centr Uzavi Vle kOncov USeka Krok Zpt Tlouka")
          (setq nextpt (getpoint strtpt (strcat
            "\nPeru/epIce/Centr/Uzavi/Vle/kOncov/"
            "USeka/Krok/Zpt/Tlouka/ <druh bod>: "))
          )
        )
        (progn
          (menucmd "s=dline3")
          (initget "Oblouk Peru epIce Uzavi Vle Krok Zpt Tlouka")
          (setq nextpt (getpoint strtpt
            "\nOblouk/Peru/epIce/Uzavi/Vle/Krok/Zpt/Tlouka/ <dal bod>: ")
          )
        )
      )
    )
    (setq v:stpt (last spts))
    (cond
      ((= nextpt "Vle")
        (dl_sao)
      )
      ((= nextpt "Tlouka")
        (dl_snw)
        
      )
      ((= nextpt "Zpt")
        (cond
          ;;((= uctr 0) (princ "\nNen co vracet. ") )
          ((= uctr 0) (setq nextpt nil) )
          ((> uctr 0) 
            (command "_u")
            (setq spts   (dl_lsu spts 1))
            (setq savpts (dl_lsu savpts 2))
            (setq wnames (dl_lsu wnames 2))
            (setq uctr (- uctr 2))
            (setq strtpt (last spts))
          )
        ) 
        (if dl:snp
          (if (= uctr 0)
            (dl_ved "brk_e1" strtpt)
          ) 
        ) 
      )
      ((= nextpt "Peru")
        (initget "ANO NE")
        (setq dl:brk (getkword 
          "\nPeruit ru v potench a koncovch bodech  NE/<ANO>: "))
        (setq dl:brk (if (= dl:brk "NE") nil T))    
        
        (if dl:snp
          (dl_ved "brk_e1" strtpt)
        )
        (if dl_arc
          (setq nextpt "Oblouk")
          (setq nextpt "USeka")
        )
      )
      ((= nextpt "Krok")
        (dl_sso)
      )
      ((= nextpt "Oblouk")
        (setq dl_arc T)               ; Pepn na volbu Obloukovho segmentu.
      )
      ((= nextpt "USeka")
        (setq dl_arc nil)             ; Pepn na volbu sekovho segmentu.
      )
      ((= nextpt "Uzavi")
        (dl_cls)
      )
      ((= (type nextpt) 'LIST)
        (dl_ds)
      )
      ((= nextpt "Centr")
        (dl_ceo)
      )
      ((= nextpt "kOncov")
        (dl_epo)
      )
      ((= nextpt "epIce")
        (endcap)                      ; Nastavuje, kter napojen m kreslit
                                      ; pi vstupu.
      )
      (T
        (setq nextpt nil cont nil)
        (if (> uctr 1)
          (if (= (logand 4 dl:ecp) 4)
            (progn
              (if (null brk_e1) (command "_line" savpt1 savpt2 ""))
              (dl_ssp)
              (if (null brk_e2) (command "_line" savpt3 savpt4 ""))
            )
            (progn
              (if (= (logand 1 dl:ecp) 1)
                (command "_line" savpt1 savpt2 "")
              )
              (if (= (logand 2 dl:ecp) 2)
                (progn
                  (dl_ssp)
                  (command "_line" savpt3 savpt4 "")
                )
              )
            )
          )
        )
        (if brk_e1 (setq brk_e1 nil))
        (if brk_e2 (setq brk_e2 nil))
        (command "_undo" "_end")
      )                               ; konec vnitn podmnky
    )                                 ; konec vnj podmnky  
  )                                   ; konec while
)
;;; ------------------ KONEC HLAVNCH FUNKC ---------------------------
;;; ---------------- ZATEK PODPRNCH FUNKC -------------------------


;;;
;;; Ukonen DLINKA pmch nebo obloukovch segment.  
;;; Jestlie kon oblouky, minimln poet segment u nakreslench je 1,
;;; jinak je 2.
;;;
;;; dl_cls == DLine_Ukonen_Segment
;;;
(defun dl_cls ()
  (if (or (and (null dl_arc) (< uctr 4)
               (if (> uctr 1)
                 (/= (dl_val 0 (entlast)) "ARC")
                 (not (> uctr 1))
               )
          )
          (and dl_arc (< uctr 2)))
    (progn 
      (princ "\nNeme ukonit -- mlo segment. ")
      (if dl_arc
        (setq nextpt "Oblouk")
        (setq nextpt "USeka")
      )
    )
    (progn
      (command "_undo" "_group")
      (setq nextpt (nth 0 spts))
      (if (null dl_arc)
        ;; Ukonen pmch segment
        (dl_mlf 3)
        (progn
          (setq tmp (last wnames)
                ange (trans '(1 0 0) (dl_val -1 tmp) 1)
                ange (angle '(0 0 0) ange)
                dir (if (= (dl_val 0 tmp) "LINE")
                      (angle (trans (dl_val 10 tmp) 0 1) 
                             (trans (dl_val 11 tmp) 0 1))
                      (progn
                        (setq dir (+ (dl_val 50 tmp) ange)
                              dir (if (> dir (* 2 pi))
                                    (- dir (* 2 pi))
                                    dir
                                  )
                        )
                        (if (equal dir
                                   (setq dir (angle (trans (dl_val 10 tmp) 
                                                           (dl_val -1 tmp) 
                                                           1)
                                                    strtpt
                                             ) 
                                   )
                                   0.01)
                          (- dir (/ pi 2))
                          (+ dir (/ pi 2))
                        )
                      )
                    )
          )
          (command "_arc" 
                   strtpt 
                   "_e" 
                   nextpt 
                   "_d"
                   (* dir (/ 180 pi))
          )
          ;; Ukonen obloukovch segment
          (dl_mlf 4)
        )
      )
      ;; nastaven nextpt na "Uzavi", co zpsob vstup.
      (setq nextpt "Uzavi"
            v:stpt nil
            cont   nil
      )
    )
  )
)
;;;
;;; Bod byl zadn, provd se bu obloukov nebo pmkov segment.
;;;
;;; dl_ds == DLine_Dl_Segment
;;;
(defun dl_ds ()
  (if (equal strtpt nextpt 0.0001)
    (progn
      (princ "\nShodn bod -- prosm zkuste znovu. ")
      (if dl_arc
        (setq nextpt "Oblouk")
        (setq nextpt "USeka")
      )
    )
    (progn
      (command "_undo" "_group")
      (setq nextpt (list (car nextpt) (cadr nextpt) (caddr strtpt)))
      (if dl_arc
        (progn
          (command "_arc" strtpt nextpt)
          (prompt "\nKoncov bod: ")
          (command pause)
          (setq nextpt (getvar "lastpoint")
                v:stpt nextpt)
          (setq temp (entlast))
          ;; Mae posledn obloukov segment, tak e meme najt ru 
          ;; nebo oblouk pod n.
          (entdel temp)
          (if dl:snp
            (dl_ved "brk_e2" nextpt)
          )
          ;; Obnoven oblouku pedem vymazanho.
          (entdel temp)
          ;; Kreslen obloukovch segment.
          (dl_mlf 2)
        )
        (progn
          (setq v:stpt nextpt)
          (if dl:snp
            (dl_ved "brk_e2" nextpt)
          )
          (if (and brk_e1 (eq brk_e1 brk_e2) (= (dl_val 0 brk_e1) "Seka"))
            (progn
              (princ "\nDruh bod nesm bt na stejnm segmentu seky. ")
              (setq brk_e2 nil)
            )
            ;; Kreslen segment seky.
            (dl_mlf 1)
          )
        )
      )
      (if brk_e2 (setq nextpt "Ven"))
    )
  )
)
;;;
;;; Volba Sted pro kreslen oblouku byla vybrna.
;;;
;;; dl_ceo == DLine_Sted_Volba
;;;
(defun dl_ceo ()
  (command "_undo" "_group")
  (setq temp T)
  (while temp
    (initget 1)
    (setq cpt (getpoint strtpt "\nBod stedu: "))
    (if (<= (distance cpt strtpt) (- (/ (getvar "tracewid") 2.0) dl:osd))
      (progn
        (princ 
        "\nPolomr definovan vbrem bodu stedu je pli mal ")
        (princ "\npro aktuln tlouku Dlinky.  ")
        (princ "Prosm vyberte jin bod.")
      )
      (setq temp nil)
    )
  )
  ;; Zatek pkazu OBLOUK, tak abychom dostali vizuln vleen.
  (command "_arc" strtpt "_c" cpt)
  (initget "Uhel Dlka Koncov ")
  (setq nextpt (getkword "\nhel/Dlka ttivy/<Koncov bod>: "))
  (cond 
    ((= nextpt "Uhel")
      (prompt "\nSeven hel: ")
      (command "_a" pause)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )
    ((= nextpt "Dlka")
      (prompt "\nDlka ttivy: ")
      (command "_l" pause)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )
    (T
      (prompt "\nKoncov bod: ")
      (command pause)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )
  )
)
;;;
;;; Volba pro Koncov bod byla vybrna.
;;;
;;; dl_epo == DLine_Koncov_Bod_Volba
;;;
(defun dl_epo ()
  (command "_undo" "_group")
  (initget 1)
  (setq cpt (getpoint "\nKoncov bod: "))
  ;; Zatek pkazu OBLOUK, tak abychom dostali vizuln vleen.
  (command "_arc" strtpt "_e" cpt)
  (initget "Uhel Smr Rdius Centr")
  (setq nextpt (getkword "\nhel/Smr/Rdius/<Centr>: "))
  (cond 
    ((= nextpt "Uhel")
      (prompt "\nSeven hel: ")
      (command "_a" pause)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )
    ((= nextpt "Smr")
      (prompt "\nTangenciln smr: ")
      (command "_d" pause)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )          
    ((= nextpt "Rdius")
      (setq temp T)
      (while temp
        (initget 1)
        (setq rad (getdist cpt "\nRdius: "))
        
        (if (or (<= rad (/ (getvar "tracewid") 2.0))
                (< rad (/ (distance strtpt cpt) 2.0)))
          (progn
            (princ "\nZadan polomr je men ne 1/2 ")
            (princ "tlouky ry nebo je neplatn")
            (princ "\npro vybranch koncovch bod.  ")
            (princ "Prosm zadejte polomr vt ne ")
            (if (< (/ (getvar "tracewid") 2.0) 
                   (/ (distance strtpt cpt) 2.0))
              (princ (rtos (/ (distance strtpt cpt) 2.0)))
              (princ (rtos (/ (getvar "tracewid") 2.0)))
            )
            (princ ". ")
          )
          (setq temp nil)
        )
      )
      (command "_r" rad)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )
    (T
      (prompt "\nCentr: ")
      (command pause)
      (setq nextpt (dl_vnp)
            v:stpt nextpt
      )
      ;; Kreslen obloukovch segment.
      (dl_mlf 2) 
    )
  )
)
;;;
;;; Nastaven koncovch bod pro napojen DLINKY.
;;;
;;; dl_ssp == DLine_Nastaven_lonch_Bod
;;;
(defun dl_ssp ( / temp)
  (setq temp (length savpts))
  (if (> temp 1)
    (progn
      (setq savpt3 (nth (- temp 2) savpts)
            savpt4 (nth (- temp 1) savpts)
      )
    )
  )
)
;;;
;;; Nastaven vyrovnvn "zdvojenou" ru do jedn z nsledujcch hodnot:
;;;   
;;;   Lev      == -1/2 tlouky (Reln slo)
;;;              > -1/2 tlouky (Reln slo)
;;;   Centrln == 0.0
;;;              < +1/2 tlouky (Reln slo)
;;;   Prav     == +1/2 tlouky (Reln slo)
;;;
;;; Vechny vyrovnvc volby jsou brny tak, jako kdybyste stli v potenm
;;; bodu ry nebo oblouku a dvali se ve smru koncovho bodu, piem lev a 
;;; zporn hodnoty jsou na lev stran, centrln nebo 0.0 jsou pmo na e
;;; a prav nebo kladn jsou na prav stran.
;;; 
;;; Zadnm relnho sla rovnmu 1/2 tlouky se nastavuje absolutn
;;; dlka posuvu ze stedov ry. Specifikace stejn posuvn dlky pouitm
;;; klovch slov k rutin aby zmnila dlku posuvu, tak aby doshla  
;;; 1/2 tlouky, kdykoliv bude zmnna.
;;;
;;; POZNMKA: Jestlie chcete umonit pesun umstn ven z obou oblouk nebo
;;;           ar, kter byly vytvoen, mete nastavit lokln promnn 
;;;           "dragos" = T, na tvrt dce defun, co kontroluje hodnotu posuvu,
;;;           kter byla zadna, zda nen vt nebo men ne 
;;;           + nebo - TRACEWID / 2.
;;;      
;;;      Muste si bt vdomi, e vsledky, toto dovolujc, nemus bt zejm
;;;      nebo nezbytn sprvn. Zvlt, kdy kreslen ry s tlouku 1 a
;;;      posuvem 4, a kdy kreslte segmenty po sob, protnou samy sebe.
;;;      
;;;      dl 0,0,0 10,0,0 10,5 pak 5,5
;;;      
;;;      Avak, toto me bt zcela uiten pro tvoen rovnobnch ar.
;;;      
;;; dl_sao == DLine_Nastaven_Vyrovnvc_Volb
;;;
(defun dl_sao (/ temp dragos)
  (initget "Lev Centr Prav")
  (setq temp dl:osd)
  ;;(setq dragos T)                   ; Viz poznmku nahoe.
  (setq dl:osd (getreal (strcat
    "\nNastavte pozice pesunu na Lev/Centr/Prav/<Ekvid. ze stedu = "
    (rtos dl:osd) ">: ")))
  (cond
    ((= dl:osd "Lev")
      (setq dl:aln 1
            dl:osd (- (/ (getvar "tracewid") 2.0))
      )
    )
    ((= dl:osd "Centr")
      (setq dl:aln 0
            dl:osd 0.0
      )
    )
    ((= dl:osd "Prav")
      (setq dl:aln 2
            dl:osd (/ (getvar "tracewid") 2.0)
      )
    )
    ((= (type dl:osd) 'REAL)
      (if dragos
        (setq dl:aln nil)
        (progn
          (setq dl:aln nil)
          (if (> dl:osd (/ (getvar "tracewid") 2.0))
            (progn
              (princ "\nZadan hodnota je mimo meze. Penastavte ji na ")
              (princ (/ (getvar "tracewid") 2.0))
              (setq dl:osd (/ (getvar "tracewid") 2.0))
            )
          )
          (if (< dl:osd (- (/ (getvar "tracewid") 2.0)))
            (progn
              (princ "\nZadan hodnota je mimo meze. Penastavte ji na ")
              (princ (- (/ (getvar "tracewid") 2.0)))
              (setq dl:osd (- (/ (getvar "tracewid") 2.0)))
            )
          )
        )
      )
    )
    (T
      (setq dl:osd temp)
    )
  )
)
;;;
;;; Nastaven nov tlouky DLINKY.
;;;
;;; dl_snw == DLine_Nastaven_Nov_Tlouky
;;;
(defun dl_snw ()
  (initget 6)
  (setvar "tracewid"
    (if (setq temp (getdist (strcat 
      "\nNov tlouka DLINKY <" (rtos (getvar "tracewid")) ">: ")))
      temp
      (getvar "tracewid") 
    ) 
  )
  (if dl:aln
    (cond
      ((= dl:aln 1) ; lev vyrovnan
        (setq dl:osd (- (/ (getvar "tracewid") 2.0)))
      )
      ((= dl:aln 2) ; prav vyrovnan
        (setq dl:osd (/ (getvar "tracewid") 2.0))
      )
      (T
        (princ)     ; centrln vyrovnan
      )
    )
  )
)
;;;
;;; Provd posuv potenho bodu z danho bodu k dalmu bodu. Vzdlenost mezi
;;; tmito body je implicitn, ale me bt i zadna.
;;; Jestlie se zad zporn slo, pouv se jako procento ze vzdlenosti 
;;; z "Posuv od" bodu k "Posuv k" bodu, tj., jestlie je zadno -75, vrac se
;;; bod, vzdlen 75% vzdlenosti mezi oba zadan body.
;;; 
;;;
;;; dl_ofs == DLine_Posuv_Potenho bodu
;;;
(defun dl_ofs ()
  (menucmd "s=osnapb")
  (initget 1)
  (setq strtpt (getpoint "\nEkvidistanta z: "))
  (initget 1)
  (setq nextpt (getpoint strtpt "\nEkvidistanta k: "))
  
  (setq dist (getdist strtpt (strcat
    "\nZadejte vzdlenost Ekvidistanty <" (rtos (distance strtpt nextpt)) 
    ">: ")))
  (setq dist (if (or (= dist "") (null dist))
               (distance strtpt nextpt)
               (if (< dist 0)
                 (* (distance strtpt nextpt) (/ (abs dist) 100.0))
                 dist
               )
             )
  )              
  (setq strtpt (polar strtpt
                      (angle strtpt nextpt)
                      dist
               ) 
  )
  (setq temp nil)
  (command "_undo" "_group")
)
;;;
;;; Nastavuje volby kroku na ANO, NE nebo nastavuje velikosti hledan oblasti,
;;; pouitm (ssget point) pes "pickbox". Tato hodnota je ohraniena pro
;;; zabudovan ovladae obrazovky na 10 pixel. Pro ADI ovladae me bt nutn
;;; vloit toto slo upravenm "MAXSNP" na zatek tohoto souboru.
;;;
;;; dl_sso == DLine_Nastaven_Krokovch_Voleb
;;;
(defun dl_sso ()
  (initget "ANO NE Velikost")
  (setq ans (getkword
    "\nNastavte velikost kroku nebo krok Ano/Ne. Velikost/NE/<ANO>: "))
  (if (= ans "NE") 
    (progn
      (setq dl:snp nil)
      (setvar "pickbox" 0) 
    )
    (if (= ans "Velikost") 
      (progn
        (setq dl:snp T ans 0)
        (while (or (< ans 1) (> ans MAXSNP))
          (setq ans (getint (strcat
            "\nNov velikost kroku (1 - " (itoa MAXSNP) ") <" (itoa dl:opb) ">: ")))

          (if (or (= ans "") (null ans))
            (setq ans dl:opb)
          )
        )
        (setvar "pickbox" ans)
        (setq dl:opb ans)
      )
      (progn
        (setq dl:snp T)
        (setvar "pickbox" dl:opb)
      )  
    ) 
  )
  (if dl:snp
    (if (= uctr 0)
      (dl_ved "brk_e1" strtpt)
    ) 
  ) 
  (if dl_arc
    (setq nextpt "Oblouk")
    (setq nextpt "USeka")
  )

)
;;;
;;; Zskn a oven smru vysunut entity na potenm nebo koncovm bodu 
;;; ry nebo oblouku, kter kreslme.
;;;
;;; dl_ved == DLine_Oven_Vysouvacho_Smru
;;;
(defun dl_ved (vent pt)
  ;; Bere entitu pro peruen, pokud uivatel vybral DLINKU.
  ;; Ovuje si, zda je to ra nebo oblouk a jestli jejich smr vysunut
  ;; je rovnobn s aktulnm USS.
  (if (set (read vent) (ssget pt))
    (progn
      (set (read vent) (ssname (eval (read vent)) 0))
      (if (and 
            (or (= (dl_val 0 (eval (read vent))) "ARC")
                (= (dl_val 0 (eval (read vent))) "LINE")
            )
            (equal (caddr(dl_val 210 (eval (read vent))))
                   (caddr(trans '(0 0 1) 1 0)) 0.001)
          )
        (princ)
        (progn
          (princ (strcat
            "\nNalezen entita nen oblouk nebo seka, "
            "nebo nen rovnobn s aktulnm USS. "))
          (set (read vent) nil)
        )
      )
    )
  )
  (eval (read vent))
)
;;;
;;; Oven nextpt.
;;; Bere bod z oblouku na opanm konci od potenho bodu (strtpt).
;;;
;;; dl_vnp == DLine_Oven_NextPt
;;;
(defun dl_vnp (/ temp cpt ang rad)

  (setq temp (entlast))
  (if (= (dl_val 0 temp) "LINE")
    (setq nextpt (if (equal strtpt (dl_val 10 temp) 0.001)
                   (dl_val 11 temp)
                   (dl_val 10 temp)
                 )
    )
    ;; Pak to mus bt oblouk...
    (progn
      ;; bere jeho stedov bod
      (setq cpt  (trans (dl_val 10 temp) (dl_val -1 temp) 1)
            ang  (dl_val 50 temp)     ; poten hel
            rad  (dl_val 40 temp)     ; polomr
      )
      (setq ange (trans '(1 0 0) (dl_val -1 temp) 1)
            ange (angle '(0 0 0) ange)
            ang (+ ang ange)
      )
      (if (> ang (* 2 pi))
        (setq ang (- ang (* 2 pi)))
      )
      (setq nextpt (if (equal strtpt (polar cpt ang rad) 0.01)
                     (polar cpt (dl_val 51 temp) rad)
                     (polar cpt ang rad)
                   )
      )
    )
  )
)
;;; ----------------- Funkce na Kreslen Hlavn seky -------------------
;;;
;;; Kreslen seek.
;;;
;;; dl_mlf == DLine_Hlavn_sekov_Funkce
;;;
(defun dl_mlf (flg / temp1 temp2 newang ang1 ang2 
                     ent cpt ang rad1 rad2 sent1 sent2
                     tmpt1 tmpt2 tmpt3 tmpt4)

  ;; Oven nextpt
  (if (null nextpt) (setq nextpt (dl_vnp)))
  
  (if (equal nextpt (nth 0 spts) 0.01)
    (if dl_arc
      (setq flg 4)
      (setq flg 3)
    )
  )
   
  (setq temp1  (+ (/ (getvar "tracewid") 2.0) dl:osd)
        temp2  (- (getvar "tracewid") temp1)
        newang (angle strtpt nextpt)
        ang1   (+ (angle strtpt nextpt) (/ pi 2))
        ang2   (- (angle strtpt nextpt) (/ pi 2))
  )
  (cond
    ((= flg 1)                        ; pokud kresl seky
      (dl_dls nil ang1 temp1)         ; Kreslen 1 segmentu
      (dl_dls nil ang2 temp2)         ; Kreslen 2 segmentu
    )
    ((or (= flg 2) (= flg 4))         ; jinak kresl oblouky...
      (setq tmp (entlast)             ; bere posledn obloukovou entitu
            ent  (entget tmp)         ; (tj., dc ru)
            ;; bere jeji stedov bod
            cpt  (trans (dl_val 10 tmp) (dl_val -1 tmp) 1) 
            ang  (dl_val 50 tmp)      ; poten hel
      )
      (setq ange (trans '(1 0 0) (dl_val -1 tmp) 1)
            ange (angle '(0 0 0) ange)
            ang (+ ang ange)
      )
      (if (> ang (* 2 pi))
        (setq ang (- ang (* 2 pi)))
      )
     
      ;; pokud poten hel potebuje kontrolu
      (if (equal (angle cpt strtpt) ang 0.01)   
        (progn
          ;; Poten hel potebuje kontrolu.
          (setq strt_a T
                rad1  (+ (dl_val 40 tmp) temp2) ; vnj polomr
                rad2  (- (dl_val 40 tmp) temp1) ; vnitn polomr
          )
          (setq ent (subst (cons 40 rad2) ; modifikace polomr
                           (assoc 40 ent) 
                           ent))
          (entmod ent) 
          (dl_atl)                   ; Pipojen jmna pro listovn
          (setq save_1 ent)
          (setq sent1 (dl_val -1 tmp))                            
          (if (= flg 4)
            (if (> uctr 2)
              (dl_das 0 rad2 50)     ; modifikace obloukovho endpt a ukonen
            )
            (dl_das nil rad2 50)     ; jinak modifikace obloukovho endpt
          )
          ;;Vytvoen "rovnobnho" oblouku
          (command "_offset" (getvar "tracewid") ; posuv oblouku
                            (list tmp '(0 0 0)) 
                            (polar cpt ang (+ 1 rad1 rad2))
                            "")
          (setq tmp (entlast)         ; bere posunut oblouk
                ent  (entget tmp))
          (dl_atl)                    ; Pipojen jmna pro listovn
          (setq save_2 ent)
          (setq sent2 tmp) 
          (if (= flg 4)
            (if (> uctr 3)
              (progn
                (dl_das 1 rad1 50)    ; modifikace obloukovho endpt a ukonen

                ;; nastaven nextpt na "Uzavi", co zpsobuje vstup.
                (setq nextpt "Uzavi"
                      v:stpt nil
                      cont   nil
                )
              )
            )
            (dl_das nil rad1 50)     ; jinak modifikuje obloukov endpt
          )

        )
        (progn                       ; pokud koncov hel potebuje kontrolu
          ;; Koncov hel potebuje kontrolu.
          (setq strt_a nil
                rad1  (+ (dl_val 40 tmp) temp1) ; vnj polomr
                rad2  (- (dl_val 40 tmp) temp2) ; vnitn polomr
          )
          (setq ent (subst (cons 40 rad1) ; modifikace polomr
                           (assoc 40 ent) 
                           ent))
          (entmod ent)                             
          (dl_atl)                   ; Pipojen jmna pro listovn
          (setq save_1 ent)
          (setq sent1 (dl_val -1 tmp))                            
          (if (= flg 4)
            (if (> uctr 2)
              (dl_das 0 rad1 51)     ; modifikace obloukovho endpt a ukonen
            )
            (dl_das nil rad1 51)     ; jinak modifikace obloukovho endpt
          )
          ;; Vytvoen "rovnobnho" oblouku
          (command "_offset" (getvar "tracewid")    
                            (list tmp '(0 0 0)) 
                            cpt 
                            "")
          (setq tmp (entlast)         ; bere posledn obloukovou entitu
                ent  (entget tmp))
          (dl_atl)                    ; Pipojen jmna pro listovn
          (setq save_2 ent)
          (setq sent2 tmp)
          (if (= flg 4)
            (if (> uctr 3)
              (progn
                (dl_das 1 rad2 51)    ; modifikace obloukovho endpt a ukonen

                ;; nastaven nextpt na "Uzavi", co zpsob vstup
                (setq nextpt "Uzavi"
                      v:stpt nil
                      cont   nil
                )
              )
            )
            (dl_das nil rad2 51)      ; jinak modifikace obloukovho endpt
          )
        )
      )

    )
    ((= flg 3)                        ; v ppad pmho ukonen
      (setq nextpt (nth 0 spts)
            ang1   (+ (angle strtpt nextpt) (/ pi 2))
            ang2   (- (angle strtpt nextpt) (/ pi 2))
      )
      (dl_dls 0 ang1 temp1)
      (dl_dls 1 ang2 temp2)

      ;; nastaven nextpt na "Uzavi", co zpsob vstup
      (setq nextpt "Uzavi"
            v:stpt nil
            cont   nil
      )
    )
    (T
      (princ "\nCHYBA:  Hodnota je mimo meze. ")
      (exit)
    )
  )
  (setq strtpt nextpt   
        spts   (append spts (list strtpt))
        savpts (append savpts (list savpt3))
        savpts (append savpts (list savpt4))
  )
  (command "_undo" "_e")                ; jen konec, kdy DLINE byla nakreslena
)
;;; --------------------- Konec Podprnch Funkc ------------------------
;;; ---------------- Zatek Funkc na Kreslen seky -------------------
;;;
;;; Pm DLINE funkce
;;;
;;; dl_dls == DLine_Kreslen_sekovho_Segmentu
;;;
(defun dl_dls (flgn ang temp / j k pt1 pt2 tmp1 ent1 p1 p2)

  (mapcar                             ; bere koncov body posuvn ry
    '(lambda (j k)
       (set j (polar (eval k) ang temp))
     )      
     '(pt1 pt2)
     '(strtpt nextpt)
  )
  (cond
    ((= uctr 0)
      ;; Nastaven bod 1 a 2 pro segment 1.
      (setq p1 (if (dl_l01 brk_e1 "1" pt1 pt2 strtpt) ipt savpt1)) 
      (setq pt2 (if (dl_l01 brk_e2 "3" pt2 pt1 nextpt) ipt savpt3))
      (setq pt1 p1)
    )
    ((= uctr 1)
      ;; Nastaven bod 1 a 2 pro segment 2.
      (setq p1 (if (dl_l01 brk_e1 "2" pt1 pt2 strtpt) ipt savpt2))
      (setq pt2 (if (dl_l01 brk_e2 "4" pt2 pt1 nextpt) ipt savpt4))
      (setq pt1 p1)
      
      ;; Tady peruuje seku nebo oblouk, nalezen v potenm bod, pokud 
      ;; takov existuje a my jsme nachystan na peruen.
      (if (and dl:brk brk_e1)
        (progn
          (command "_break" brk_e1 savpt1 savpt2)
        )
      )
      ;; Tady peruuje seku nebo oblouk, nalezen v koncovm bod, pokud 
      ;; takov existuje a my poadujeme peruen.
      (if (and dl:brk brk_e2)
        (progn
          (if (eq brk_e1 brk_e2)
            (progn
              ;; Mae prvn seku, tak e meme najt oblouk nebo seku,
              ;; kterou jsme nali pedtm.
              (entdel (nth 0 wnames))  
              (dl_ved "brk_e2" nextpt)
              ;; Obnoven prvn seky
              (entdel (nth 0 wnames))
            )
          )
          (command "_break" brk_e2 savpt3 savpt4)
        )
      )
      ;; Nenastavuje brk_e2 na nulu... bude nastavena pozdji.
    )
    ((= (rem uctr 2.0) 0)    
      (setq fang nil)
      (setq p1 (dl_dl2 pt1))          ; Kreslen 2 sti seky
      (setq pt2 (if (dl_l01 brk_e2 "3" pt2 pt1 strtpt) 
                  ipt
                  savpt3
                )
      )
      (setq pt1 p1)
      (if flgn                        ; jestlie kon
        (progn
          (setq tmp1 (nth flgn wnames)
                ent1 (entget tmp1)    ; bere odpovdajc pedchoz entitu
          )
          (if (= (dl_val 0 tmp1) "LINE")
            ;; jestlie je seka
            (setq pt2 (dl_mls nil 10))           
            ;; jestlie je oblouk
            (setq pt2 (dl_mas T nil pt2 pt1 nil))  
          )
        )                             
      )
    )
    (T
      (setq p1 (dl_dl2 pt1))              ; Kreslen 2 sti seky
      (setq pt2 (if (dl_l01 brk_e2 "4" pt2 pt1 nextpt) 
                  ipt
                  savpt4
                )
      )
      (setq pt1 p1)
      (if flgn                        ; jestlie kon
        (progn
          (setq tmp1 (nth flgn wnames)
                ent1 (entget tmp1)    ; bere odpovdajc pedchoz entitu
                brk_e1 nil
                brk_e2 nil
          )
          (if (= (dl_val 0 tmp1) "LINE")
            ;; jestlie je seka
            (setq pt2 (dl_mls nil 10))           
            ;; jestlie je oblouk
            (setq pt2 (dl_mas T nil pt2 pt1 nil))  
          )
        )                             
      )
      ;; Tady peruuje seku nebo oblouk, nalezen v koncovm bod, pokud 
      ;; takov existuje a my poadujeme peruen.
      (if (and dl:brk brk_e2)
        (progn
          (command "_BREAK" brk_e2 savpt3 savpt4)
        )
      )
      ;; Nenastavuje brk_e2 na nulu... bude nastavena pozdji.
    )
  )
  (command "_LINE" pt1 pt2 "")         ; kresl seku
  (setq wnames (if (null wnames) 
                 (list (setq elast (entlast)) )
                 (append wnames (list (setq elast (entlast)))))
        uctr   (1+ uctr)
  )
  wnames
)
;;;
;;; Nastavuje pt1 nebo pt2  podle toho, jestli se peruuje oblouk nebo seka
;;;
;;; dl_l01 == DLine_draw_Lines_0_and_1
;;;
(defun dl_l01 (bent1 n p1 p2 pt / temp)
  (setq n (strcat "savpt" n))
  (setq spt nil)
  (if bent1
    (if (= (dl_val 0 bent1) "LINE")
      (progn
        (setq temp (inters (trans (dl_val 10 bent1) 0 1)
                            (trans (dl_val 11 bent1) 0 1)
                            p1
                            p2
                            nil
                    )
        ) 
        (if temp
          (set (read n) temp)
          (progn
            (set (read n) p1)
            (setq brk_e1 nil)
          )
        )
      )
      (progn
        (set (read n) (dl_ial bent1 p1 p2 pt))
        ;; Spt se nastavuje jen tehdy, kdy neexistuje prsek
        (if spt
          (progn
            (setq ipt (eval (read n)))
            (set (read n) spt)
          )
        )
      )
    )
    (set (read n) p1)
  )
  (if spt
    T
    nil
  )
)
;;;
;;; Dl vce seku kreslcch zleitost.  Odtud volte modifikan 
;;; funkce pro pedchoz obloukov nebo sekov segmenty. Konec seky je
;;; modifikovn vdy na konci skupiny 11, testujete poten a koncov
;;; hel oblouku ke zjitn, kter konec se bude modifikovat.
;;;
;;; dl_dl2 == DLine_Draw_Line_segment_part_2
;;;
(defun dl_dl2 (npt)
  (setq tmp1 (nth (- uctr 2) wnames)
        ent1 (entget tmp1))           ; bere odpovdajc pedchoz entitu
   
  (if (= (dl_val 0 tmp1) "LINE")  
    ;; Check angles 0 180, -180  and 360...   
    (if (or  (equal (angle strtpt nextpt)
                   (angle (trans (dl_val 10 tmp1) 0 1)
                          (trans (dl_val 11 tmp1) 0 1)) 0.001)
             (equal (angle strtpt nextpt)
                   (angle (trans (dl_val 11 tmp1) 0 1)
                          (trans (dl_val 10 tmp1) 0 1)) 0.001)
             (equal (+ (* 2 pi) (angle strtpt nextpt))
                   (angle (trans (dl_val 10 tmp1) 0 1)
                          (trans (dl_val 11 tmp1) 0 1)) 0.001)
        )
      ;; jestlie je seka
      (progn
        (setq brk_e2 nil)
        (command "_LINE" (trans (dl_val 11 tmp1) 0 1) pt1 "") 
        pt1 
      )
      ;; jinak, jestlie je oblouk
      (progn
        (dl_mls nil 11)
      )
    )
    ;; if it's an arc
    (dl_mas nil nil pt1 pt2 strtpt)  
  )
)
;;;
;;; Mn koncov bod seky
;;;
;;; dl_mls == DLine_Modify_Line_Segment
;;;
(defun dl_mls (flg2 nn / spt ept pt)  ; flg2 = nil jestlie je seka k sece
                                      ;      = T   jestlie je seka k oblouku

  ;; Toto je pedel entita; seka
  (setq spt (trans (dl_val 10 tmp1) 0 1)   
        ept (trans (dl_val 11 tmp1) 0 1)
  )
  (if flg2
    ;; nalz prsek s obloukem; tmp == ename oblouku
    (progn
      ;; nalz prsek s sekou; tmp == ename oblouku.
      (setq pt (dl_ial tmp spt ept (if flgn nextpt strtpt)))
    )

    ;; nalz prsek s sekou
    (setq pt (inters spt ept pt1 pt2 nil)) 
  )
  ;; mn pedchoz seku
  (if pt 
    (entmod (subst (cons nn (trans pt 1 0)) 
                   (assoc nn ent1) 
                   ent1))
    (setq pt pt2)
  )
  pt
)
;;; 
;;; Tato rutina e rozlin lohy: pot vzdlenost od stedu
;;; oblouku (nebo shodnch krunic) k sece, potom vypot
;;; dva prseky seky a oblouku, nakonec zkus urit , kter 
;;; z tchto bod lpe vyhovuje nsledujcm kritrim :
;;; 
;;; 
;;;   1) Jeden konec oblouku mus leet "na" sece, nebo
;;;      jeden konec seky mus leet na oblouku. 
;;;   2) Dejme tomu, e bod zskan podle kritria 1 je p1,
;;;      druh bod je p2, potom jestlie oblouk k seku,
;;;      seka pouije bod  p2, jinak kdy oblouk seku 
;;;      nek, tak pouije bod p1.
;;;      
;;; Jestlie se seka a oblouk neprotnaj, bude seka kreslena
;;; z prseku oblouku a kolmice z seky ke stedu oblouku, a seky; 
;;; seka a oblouk budou oezny nebo prodloueny, tak jak je teba,
;;; aby doshly tchto bod.
;;; 
;;; Jestlie seka a oblouk jsou ten, potom jsou oblouk  a seka
;;; oezny/prodloueny do tohoto bodu.
;;;
;;; p1 a p2 jsou dva body na sece
;;; ename  == jmno obloukov entity
;;; flg == T kdy nakreslen segment kon na oblouku
;;; flg == nil kdy nakreslen segment na oblouku zan
;;;
;;; dl_ial == DLine_Intersect_Arc_with_Line
;;;
(defun dl_ial (arc pt_1 pt_2 npt / d pi2 rad ang nang temp ipt)

  (setq cpt  (trans (dl_val 10 arc) (dl_val -1 arc) 1)  
        pi2  (/ pi 2)                 ; 1/2 pi
        ang  (angle pt_1 pt_2)                   
        nang (+ ang pi2)              ; kolmice k "ang"
        temp (inters pt_1 pt_2 cpt (polar cpt nang 1) nil)
        nang (angle cpt temp)
  )
  ;; bere kolmou vzdlenost stedu oblouku k sece.
  (setq d (distance cpt temp))

  (cond
    ((equal (setq rad (dl_val 40 arc)) d 0.01)
      ;; Jeden prsek.
      (setq ipt temp)
    )
    ((< rad d)                       
      ;; Bez prseku.
      (setq spt (polar cpt nang rad)
            ipt temp
      )
      (command "_LINE" spt ipt "")
      ipt
    )
    (T
      ;; Dva prseky. Nyn...
      ;; kdy kresl oblouky, fang je nastaven, po oputn prvnho segmentu...
      ;; Penastav `near' bod na zklad pedchozho ipt. To me bt
      ;; zcela rozdln a nezbytn od `npt' jt mimo.
      (if (and dl_arc fang (> uctr 1)) 
        (setq npt (polar cpt fang rad))
      )
      (dl_g2p npt)
      (setq ipt (dl_bp arc pt_1 pt_2 ipt1 ipt2))
      ;; jestlie `fang' nen nastaven, nastav se, jinak se nastav na nil.
      (if fang 
        (setq fang nil)
        (if dl_arc (setq fang (angle cpt ipt)))
      )
      ipt
    )
  )
)
;;;
;;; Zsk dva prseky, v zvislosti na tom, zda ipt1
;;; je bli od tchto dvou bod k bodu "npt".
;;;
;;; dl_g2p == DLine_Get_2_Points
;;;
(defun dl_g2p (npt / temp l theta)
  (if (equal d 0.0 0.01)
    (setq theta pi2
          nang (+ ang pi2)            ; Kolmice k "ang"
    )
    (setq l     (sqrt (abs (- (expt rad 2) (expt d 2))))
          theta (abs (atan (/ l d)))
    )
  )
  ;; bere dva hly k nekonenm prsekm shodnch krunic
  ;; s obloukem, a seka , potom bere dva prseky.
  ;;
  (setq ipt1 (polar cpt (- nang theta) rad))
  (setq ipt2 (polar cpt (+ nang theta) rad))
  ;; Set the closer of the two points to npt to be ipt1.
  (if (< (distance ipt2 npt) (distance ipt1 npt))
    ;; Vymn body
    (setq temp ipt1
          ipt1 ipt2
          ipt2 temp
    )
    (if (equal (distance ipt2 npt) (distance ipt1 npt) 0.01)
      (exit)
    )
  )
  ipt1
)
;;;
;;; Test bodu `pt' , zda le na sece `sp--ep'.
;;;
;;; dl_onl == DLine_ON_Line_segment
;;;
(defun dl_onl (sp ep pt / cpt sa ea ang)
  (if (inters sp ep pt
              (polar pt (+ (angle sp ep) (/ pi 2))
                     (/ (getvar "tracewid") 10)
              )
              T)
    T 
    nil
  )
)
;;;
;;; Test bodu `pt', zda le na oblouku `arc'.
;;;
;;; dl_ona == DLine_ON_Arc_segment
;;;
(defun dl_ona (arc pt / cpt sa ea ang)
  (setq cpt (trans (dl_val 10 arc) (dl_val -1 arc) 1) 
        sa  (dl_val 50 arc)           ; hel aktuln ent poten bod
        ea  (dl_val 51 arc)           ; hel aktuln ent koncov bod
        ang (angle cpt pt)            ; hel k pt.
  )
  (if (> sa ea)
    (if (or (and (> ang sa) (< ang (+ ea (* 2 pi))))
            (and (> ang (- ea (* 2 pi))) (< ang ea))
        ) 
      T 
      nil
    )
    (if (and (> ang sa) (< ang ea)) T nil)
  )
)
;;;
;;; Bere nejvhodnj prsek oblouku a seky.  
;;; Kritria jsou nsledujc:
;;; 
;;;   1) Bod le jak na oblouku tak na sece
;;;   2) Bude to bod, kter zpsobuje nejmen hel vytvoen tak,
;;;      e vyhovuje (1).
;;;   3) Jestlie kon,potom vdy pouije bod nejbli nextpt. Krom situace,
;;;      kdy body jsou stejn vzdlen, potom pouije kritria 1 a 2 k vzanmu peruen.
;;;   4) Jestlie peruen oblouku sekou, vdy pouvaj body nejbli
;;;      bodu peruen.
;;;
;;; dl_bp == DLine_Best_Point_of_arc_and_line
;;;
(defun dl_bp (en1 p1 p2 pp1 pp2 / temp temp1 temp2)
  (setq temp1 (dl_onl p1 p2 pp2)
        temp2 (dl_ona en1 pp2)
        temp  (if (or (= flg 1) (= flg 3)) T nil)
  )
  (if (and temp1 temp2)
    (if (and (< uctr 2) 
             (and brk_e1 brk_e2))
      pp1
      (if (and temp (not fang)) pp1 pp2)
    )
    pp1
  )
)
;;; ----------------- Konec funkc pro kreslen seky --------------------
;;; ---------------- Zatek funkc pro kreslen oblouku-------------
;;;
;;; Kresl oblou DLINKU
;;;
;;; dl_das == DLine_Draw_Arc_Segment
;;;
(defun dl_das (flgn orad nn / tmp1 ent1 pt ang )
  (cond
    ((= uctr 0)
      (setq sent1 tmp)
      (dl_a01 brk_e1 "1" strtpt nil)  ; DLinka_kresl_oblouk(Arc)_0_a_1
      (dl_a01 brk_e2 "3" nextpt T)    ; DLinka_kresl_oblouk(Arc)_0_a_1
    )
    ((= uctr 1)
      (setq sent1 tmp)
      (dl_a01 brk_e1 "2" strtpt nil)  ; DLinka_kresl_oblouk(Arc)_0_a_1
      (dl_a01 brk_e2 "4" nextpt T)    ; DLinka_kresl_oblouk(Arc)_0_a_1
      (dl_mae nil T)
      (dl_mae nil nil)
      ;; Tady peruuje seku nebo oblouk, nalezen v potenm bod, pokud 
      ;; takov existuje a my poadujeme peruen.
      (if (and dl:brk brk_e1)
        (progn
          (dl_mae T T)
          (dl_mae T nil)
          (command "_BREAK" brk_e1 savpt1 savpt2)
        )
      )
      ;; Nenastavuje brk_e1 na nil... nastav se pozdji
      ;; Tady peruuje seku nebo oblouk, nalezen v koncovm bod, pokud 
      ;; takov existuje a my poadujeme peruen.
      (if (and dl:brk brk_e2)
        (progn
          (if (eq brk_e1 brk_e2)
            (progn
              ;; Vymae oba oblouky tak jak mete nalzt oblouk nebo seku kterou
              ;; jste ji nalezli pedtm.
              (entdel (nth 0 wnames))  
              (entdel (nth 1 wnames))  
              (dl_ved "brk_e2" nextpt)
              ;; Uschov prvn seku
              (entdel (nth 0 wnames))
              (entdel (nth 1 wnames))
            )
          )
          (if (null brk_e1)
            (progn
              (dl_mae T T)
              (dl_mae T nil)
            )
          )
          (command "_BREAK" brk_e2 savpt3 savpt4)
        )
      )
      ;; Nenastavuje brk_e2 na nil... nastav se pozdji
    )
    ((= (rem uctr 2.0) 0) 
      (setq fang nil)
      (dl_da2)                        ; Kresl oblouk st 2
      (if fang 
        (setq ftmp fang
              fang nil
        )
      )
      (setq save_1 ent)
      (setq sent1 (cdr(assoc -1 ent)))
      (setq pt2 (dl_a01 brk_e2 "3" nextpt T)) ; DLinka_kresl_oblouk(Arc)_0_a_1
      (if ftmp 
        (setq fang ftmp
              ftmp nil
        )
      )
    )
    (T
      (dl_da2)                        ; Kresl oblouk st 2
      (if fang 
        (setq ftmp fang
              fang nil
        )
      )
      (setq save_2 ent)
      (setq sent1 (cdr(assoc -1 ent)))
      (setq pt2 (dl_a01 brk_e2 "4" nextpt T)) ; DLinka_kresl_oblouk(Arc)_0_a_1
      (if ftmp 
        (setq fang fang
              ftmp nil
        )
      )

      ;; Tady peruuje seku nebo oblouk, nalezen v koncovm bod, pokud 
      ;; takov existuje a my poadujeme peruen.
      (if (and dl:brk brk_e2)
        (progn
          (dl_mae T T)
          (dl_mae T nil)
          (command "_BREAK" brk_e2 savpt3 savpt4)
        )
      )
      ;; Nenastavuje brk_e2 na nil... nastav se pozdji.
    )
  )
  (setq uctr   (1+ uctr))
)
;;;
;;; Nastavuje pt1 nebo pt2  podle toho, jestli se peruuje oblouk nebo seka
;;;
;;; dl_a01 == DLinka_kresl_oblouky(Arcs)_0_a_1
;;;
(defun dl_a01 (bent1 n pt flg / pt1 pt2 ang1 ang2 anga angb)
  ;; "n" je bod, kter se ulo pro dokonen epice
  (setq n (strcat "savpt" n))
  ;; "tmp" je prv vytvoen oblouk
  ;; "bent1" je seka nebo oblouk k peruen, pokud takov existuje...
  (if bent1
    (if (= (dl_val 0 bent1) "LINE")
      (progn
        (set (read n) (dl_ial tmp (trans (dl_val 10 bent1) 0 1)
                                  (trans (dl_val 11 bent1) 0 1) pt)) 
      )
      (progn
        (setq curcpt (trans (dl_val 10 sent1) (dl_val -1 sent1) 1) 
              prvcpt (trans (dl_val 10 bent1) (dl_val -1 bent1) 1)
              pt1    (polar prvcpt (dl_val 50 bent1) (dl_val 40 bent1))
              pt2    (polar curcpt (dl_val nn sent1) (dl_val 40 sent1))
              ang1   (angle prvcpt pt1)
        )
        (if (not (equal ang1 (angle prvcpt strtpt) 0.01))
          (setq pt1  (polar prvcpt (dl_val 51 bent1) (dl_val 40 bent1))
                ang1 (angle prvcpt pt1)
                ang2 (angle curcpt pt2)
                anga (- ang1 ang2)
                angb (- ang2 ang1)
          )
        )
        (if (or (and (< anga 0.0872665)
                     (> anga -0.0872665))
                (and (< angb 0.0872665)
                     (> angb -0.0872665))
            )
          (progn
            (set (read n) pt)
            (if (= bent1 brk_e1) 
              (setq brk_e1 nil)
              (setq brk_e2 nil)
            )
          )
          (set (read n) (dl_iaa sent1 bent1 pt flg))
        )
      )
    )
    (progn
      (setq cpt (trans (dl_val 10 tmp) (dl_val -1 tmp) 1))
      (set (read n) (polar cpt (angle cpt pt) orad))
    )
  )
  (eval (read n))
)
;;;
;;; Dl vce seku kreslcch zleitost.  Odtud volte modifikan 
;;; funkce pro pedchoz obloukov nebo sekov segmenty. Konec seky je
;;; modifikovn vdy na konci skupiny 11, testujete poten a koncov
;;; hel oblouku ke zjitn, kter konec se bude modifikovat.
;;;
;;; dl_da2 == DLinka_Draw_Arc_segment_st_2
;;;
(defun dl_da2 (/ pt)
  ;; bere odpovdajc pedchoz entitu
  (setq tmp1 (nth (- uctr 2) wnames) 
        ent1 (entget tmp1))
  (if (= (dl_val 0 tmp1) "LINE")     
    ;; jestlie je seka
    (setq pt (dl_mls T 11))             
    ;; jestlie je oblouk
    (setq pt (dl_mas nil T nil nil strtpt)) 
  )
  ;; pt je bod v aktuln USS, ne GSS
  (if pt
    (progn
      (setq ang (- (angle cpt pt) ange))
      (entmod (setq ent (subst (cons nn ang) 
                       (assoc nn ent) 
                       ent)))         ; mn koncov bod oblouku
    )
  )
  (if flgn                            ; jestlie kon
    (progn
      (setq tmp1 (nth flgn wnames)     
            ent1  (entget tmp1))  ; bere oznaenou (flag) entitu
      (if (= (dl_val 0 tmp1) "LINE")     
        ;; jestlie je seka
        (setq pt (dl_mls T 10))   
        ;; jestlie je oblouk
        (setq pt (dl_mas T T nil nil nextpt)) 
      )
      (if pt
        (progn
          (setq ang (- (angle cpt pt) ange))
          (setq nn (if (= nn 50) 51 50))
          (entmod (setq ent (subst (cons nn ang) 
                         (assoc nn ent) 
                         ent)))       ; mn koncov bod oblouku
        )                             
      )
    )                             
  )
)
;;;
;;; Mn koncov body oblouk tm, e zmn poten a koncov hly.
;;;
;;; dl_mae == DLine_Modify_Arc_Endpoints
;;;
(defun dl_mae (eflg sflg / nn1 nn2)
  (if (= nn 50)
    (setq nn1 50 nn2 51)
    (setq nn1 51 nn2 50)
  )
  (if sflg
    (if eflg
      (setq save_1 (subst (cons nn2 
                                (angle 
                                  (trans cpt    1 (cdr(assoc -1 save_1)))
                                  (trans savpt3 1 (cdr(assoc -1 save_1)))
                                )
                          )
                          (assoc nn2 save_1) save_1)
      )
      (setq save_1 (subst (cons nn1 
                                (angle 
                                  (trans cpt    1 (cdr(assoc -1 save_1)))
                                  (trans savpt1 1 (cdr(assoc -1 save_1)))
                                )
                          )
                          (assoc nn1 save_1) save_1)
      )
    )
    (if eflg
      (setq save_2 (subst (cons nn2 
                                (angle 
                                  (trans cpt    1 (cdr(assoc -1 save_1)))
                                  (trans savpt4 1 (cdr(assoc -1 save_2)))
                                )
                          )
                          (assoc nn2 save_2) save_2)
      )
      (setq save_2 (subst (cons nn1 
                                (angle 
                                  (trans cpt    1 (cdr(assoc -1 save_1)))
                                  (trans savpt2 1 (cdr(assoc -1 save_2)))
                                )
                          )
                          (assoc nn1 save_2) save_2)
      )
    )
  )
  (if sflg
    (entmod save_1)
    (entmod save_2)
  )
)
;;;
;;; Mn oblouk                       ; flg2 = nil jestlie je oblouk k sece
;;;                                   ;      = T   jestlie je oblouk k oblouku
;;;
;;; dl_mas == DLine_Modify_Arc_Segment
;;;
(defun dl_mas (flg3 flg2 spt ept pt / nnn pt1 pt2 rad1 ange)
;; get some stuff
  (setq cpt1   (trans (dl_val 10 tmp1) (dl_val -1 tmp1) 1)           
        rad1   (dl_val 40 tmp1)
        ang1   (dl_val 50 tmp1)
  )
  (if (null pt)                       ; jestlie bod neprochz:
    (setq pt (nth 0 spts))            ; nastav poten uloen potenho bodu
  )               
  (setq ange (trans '(1 0 0) (dl_val -1 tmp1) 1)
        ange (angle '(0 0 0) ange)
        ang1 (+ ang1 ange)
  )
  (if (> ang1 (* 2 pi))
    (setq ang1 (- ang1 (* 2 pi)))
  )
  (if (equal (angle cpt1 pt) ang1 0.01) ; figure out if we're looking
    (setq nnn 50)                     ; for the start or end point of
    (setq nnn 51)                     ; the beginning arc, then
  )                                   ; get the intersection point
  ;; jestlie je oblouk k oblouku
  (if flg2
    ;; then
    (progn
      ;; nalz prsek s obloukem
      (setq pt1 (dl_iaa tmp tmp1 (if flg3 nextpt strtpt) flg2))   
      (if pt1 
        (progn
          (setq ang1 (- (angle cpt1 pt1) ange))
          (setq ent1 (subst (cons nnn ang1) 
                            (assoc nnn ent1) 
                            ent1))                 
          (entmod ent1)               ; mn koncov bod oblouku
        )
      )
    )
    ;; else
    (progn 
      ;; nalz oblouk protnajc seku z bodu spt do ept
      (setq pt1 (dl_ial tmp1 spt ept pt)) 
      (setq ang1 (- (angle cpt1 pt1) ange))
      (setq ent1 (subst (cons nnn ang1) 
                        (assoc nnn ent1) 
                        ent1))                 
      (entmod ent1)                   ; mn koncov bod oblouku
    )
  )
  pt1
)
;;; ---------------- Zatek funkc oblouk k oblouku ---------------------
;;;
;;; Tato rutina e rozlin lohy: pot vzdlenost dvou prsek 
;;; dvou oblouk
;;; nakonec ykus urit,kter z tchto bod 
;;; nejlpe vyhov nsledujcm kritrim:
;;; 
;;;   1) jeden konec oblouku mus leet na oblouku. 
;;;   2) Dejme tomu, e bod zskan podle kritria 1 je p1,
;;;      druh bod je p2, potom jestlie oblouk k druh oblouk,
;;;      seka pouije bod  p2, jinak kdy oblouk druh oblouk 
;;;      nek, tak pouije bod p1.
;;;      
;;; Jestlie se dva oblouky neprotnaj, bude seka kreslena
;;; z prseku oblouku a kolmice z seky ke dvma stedm oblouk; 
;;; Oblouky budou oezny nebo prodloueny, tak jak je teba,
;;; aby doshly tchto bod.
;;; 
;;; Jestlie dva oblouky jsou ten, potom jsou oblouky
;;; oezny/prodloueny do tohoto bodu.
;;;
;;; Prseky dvou oblouk nebo krunic
;;; a    = radius entity se jmnem ename 1
;;; b    = vzdlenost mezi curcpt a prvcpt
;;; c    = radius entity se jmnem ename 2
;;; curcpt = stedov bodu prvn krunice nebo oblouku -- bent1, bent2, tmp
;;; prvcpt = stedov bodu druh krunice nebo oblouku -- sent1, sent2, tmp1
;;; npt  = blzk bod pro test nejbliho bodu
;;;
;;; dl_iaa == DLine_Intersect_Arc_and_Arc
;;;
(defun dl_iaa  (en1 en2 npt flga / a b c s ang alpha alph ipt 
                                   curcpt prvcpt temp temp1 temp2)
  (setq curcpt  (trans (dl_val 10 en1) (dl_val -1 en1) 1) ; the "last" entity
        prvcpt  (trans (dl_val 10 en2) (dl_val -1 en2) 1) ; the previous entity
        a       (dl_val 40 en2)
        b       (distance curcpt prvcpt)
        c       (dl_val 40 en1)
        s       (/ (+ a b c) 2.0)
        ang     (angle curcpt prvcpt)
  )
  (cond
    ;; krunice jsou ten
    ;; Jestlie (- s a) == 0, mohl bz nastat ppad dlen nulou...
    ((or (= (- s a) 0) (equal b (+ a c) 0.001) (equal b (abs (- a c)) 0.001))
      ;; Krunice jsou ten
      (setq ipt nil)
    )
    ;;Krunice se neprotnaj    
	 ((and (or (> b (+ a c)) (if (> c a) (< (+ a b) c) (< (+ c b) a)))                 
          (not (equal (+ a b ) c (/ (+ a b c) 1000000))))
      ;; dn prsek.
      (if (= flg 4) 
        (progn
          (setq ipt (polar curcpt (angle curcpt prvcpt) c))
          (command "_LINE" (polar prvcpt (angle prvcpt ipt) a) ipt "")
        )
        (progn
          (setq ipt (polar curcpt (angle curcpt prvcpt) c))
          (command "_LINE" (polar prvcpt (angle prvcpt ipt) a) ipt "")
        )
      )
    )
    (T
      ;; obecn pravidlo cos. vta    a -- (- s a) != 0
      (setq alpha (* 2.0 (atan (sqrt (abs (/ (* (- s b) (- s c)) 
                                             (* s (- s a)))))))
      )
      
      (setq tpt1 (polar curcpt (+ ang alpha) c)
            tpt2 (polar curcpt (- ang alpha) c)
            anga  (angle curcpt npt)
            angb  (angle prvcpt npt)
      )
      ;; Dva prseky. Nyn...
      ;; kdy kresl oblouky, fang je nastaven, po oputn prvnho segmentu...
      ;; Penastav `near' bod na zklad pedchozho ipt. To me bt
      ;; zcela rozdln a nezbytn od `npt' jt mimo.
      (if (and dl_arc fang (> uctr 1)) 
        (setq npt (polar prvcpt fang c))
      )
      (if (< (distance tpt1 npt) (distance tpt2 npt))
        (setq temp tpt1
              tpt1 tpt2
              tpt2 temp
        )
      )
      (setq temp (angle prvcpt curcpt)) ; hel mezi ped. ent a tuoto ent
      (setq ipt (dl_bap en1 en2 tpt2 tpt1 nil))
      (if fang 
        (setq fang nil)
        (if dl_arc (setq fang (angle cpt ipt)))
      )
    )
  )
  (setq cpt curcpt)
  (setq cpt1 prvcpt)
  ipt                                 ; bod nvratu
)
;;;
;;; Bere nejvhodnj bod pro prsek oblouk/oblouk.
;;;
;;; dl_bap == DLine_Best_Point_to_Arc
;;;
(defun dl_bap (en1 en2 pp1 pp2 flg / temp1 temp2)
  (setq temp1 (dl_ona en1 pp2)
        temp2 (dl_ona en2 pp2)
  )
  (if temp2
    (if (and (< uctr 2) 
             (and brk_e1 brk_e2))
      pp1
      (if temp1 
        (if (< uctr 2) 
          pp2
          (if (not fang) pp2 pp1)
        )
        pp1
      )
    )
    pp1
  )        
)
;;; ----------------- Konec funkc kreslen oblouku --------------------
;;; -------------------- Zatek rznch funkc -----------------------
;;;
;;; Pd jmno entity do seznamu  wnames
;;;
;;; dl_atl == DLine_Add_To_List
;;;
(defun dl_atl ()
  (setq wnames (if (null wnames) 
                 (list (entlast)) 
                 (append wnames (list tmp)))
  )
  wnames
)
;;;
;;; Hodnota  assoc sla  <ename>
;;;
(defun dl_val (v temp)
  (cdr(assoc v (entget temp)))
)
;;;
;;; Oezva seznam: odee poslednch "v" prvk ze seznamu
;;;
(defun dl_lsu (lst v / m)
  (setq m 0 temp '())
  (repeat (- (length lst) v)
    (progn
      (setq temp (append temp (list (nth m lst))))
      (setq m (1+ m))
  ) )
  temp
)
;;;
;;;Funkce nastavuje druh epice programu DLINE.
;;;
(defun endcap ()
  (initget "Auto Ob Koncovou dnou Poten")
  (setq dl:ecp (getkword 
    "\nKreslit kterou epici?  Ob/Koncovou/dnou/Poten/<Auto>: "))
  (cond
    ((= dl:ecp "dnou")
      (setq dl:ecp 0)
    )
    ((= dl:ecp "Poten")
      (setq dl:ecp 1)
    )
    ((= dl:ecp "Koncovou")
      (setq dl:ecp 2)
    )
    ((= dl:ecp "Ob")
      (setq dl:ecp 3)
    )
    (T  ; Auto
      (setq dl:ecp 4)
    )
  )
)
;;;
;;; Nastaven tchto hodnot pi natn programu.
;;;
(if (null dl:ecp) (setq dl:ecp 4))    ; implicitn koncov epice
(if (null dl:snp) (setq dl:snp T))    ; implicitn zapnut kroku
(if (null dl:brk) (setq dl:brk T))    ; implicitn peruovn
(if (null dl:osd) (setq dl:osd 0))    ; implicitn stedov upraven
;;;
;;;  c: funkce.
;;;
(defun c:dl () (dline))
(defun c:dlinka () (dline))

(princ "  DLINka natena.")
(princ)
