;======================================================================
;       <SJ-3D.lsp>            Skipy Jones               07-06-2018
;                                                       v. 18.0 [cs]
;
;                  - anglicka klicova slova pro vrstvy
;
;           DEF3D      - definice vrstev 3D
;
;           layset     - funkce pro nastaveni vrstvy
;           jmelayidf  - doplneni jmena vrstvy o identifikator
;           lalaset    - funkce pro nastaveni predchozi vrstvy
;
;           setgenroz  - nastaveni rozmeru generatoru 3D vyplni
;           setgenlay  - nastaveni vrstev generatoru 3D vyplni
;           uskocr     - uskoceni do kvadrantu o pravouhlou vzdalenost
;           ramot      - vykresleni ramu otvoru
;           vypot      - vykresleni vyplne otvoru
;           zmenz      - zmena Z souradnice
;
;           GENVYP     - generator 3D vyplni
;======================================================================

(princ "\nProsm okamik...natm SJ-3D.lsp...")

(defun c:DEF3D ( )
; definice vrstev 3D
;--------------------
  (setvar "CMDECHO" 0)
  (command "ZPT" "S")
  (command "_LAYER"
     "_N" "3D_PODLAHY" "_C" "40" "3D_PODLAHY"
     "_N" "3D_STROPY" "_C" "40" "3D_STROPY"
     "_N" "3D_STENY" "_C" "3" "3D_STENY"
     "_N" "3D_SCHODY" "_C" "2" "3D_SCHODY"
     "_N" "3D_OKNA" "_C" "5" "3D_OKNA"
     "_N" "3D_DVERE" "_C" "6" "3D_DVERE"
     "_N" "3D_OTVORY" "_C" "4" "3D_OTVORY"
     "_N" "3D_ZARIZENI" "_C" "7" "3D_ZARIZENI"
     "_N" "3D_NABYTEK" "_C" "7" "3D_NABYTEK"
     ""
  ) ; command
  (command "ZPT" "O")
  (princ)
) ; end c:DEF3D

(defun lalaset (__JMLA / __JMLA)
; funkce pro nastaveni predchozi vrstvy "__JMLA"
;------------------------------------------------
  (if __JMLA
    (command "_LAYER" "_M" __JMLA "")
  ) ; if
  (princ)
) ; end defun lalaset

(defun jmelayidf (__IJM / __IJM __DLIDELAY)
; doplneni jmena vrstvy profese STAVBA o identifikator
;------------------------------------------------------
  (if (null IDELAY) (setq IDELAY ""))

  (setq __DLIDELAY (strlen IDELAY))
  (if
    (and
      (/= IDELAY "")
      (/= (strcase
            (substr __IJM 1 (1+ __DLIDELAY))) (strcat (strcase IDELAY) "_"))
      (/= (strcase __IJM) "XREF")
      (/= (strcase (substr __IJM 1 5)) "XREF_")
      (/= (strcase (substr __IJM 1 4)) "VYK_")
      (/= (strcase (substr __IJM 1 4)) "ZAK_")
      (/= (strcase (substr __IJM 1 4)) "KRO_")
      (/= (strcase (substr __IJM 1 4)) "INT_")
      (/= (strcase (substr __IJM 1 3)) "UT_")
      (/= (strcase (substr __IJM 1 4)) "KAN_")
      (/= (strcase (substr __IJM 1 4)) "VOD_")
      (/= (strcase (substr __IJM 1 4)) "PLY_")
      (/= (strcase (substr __IJM 1 3)) "EL_")
      (/= (strcase (substr __IJM 1 4)) "VZT_")
      (/= (strcase (substr __IJM 1 3)) "3D_")
    ) ; and

    (strcat (strcase IDELAY) "_" __IJM)  ;...navrat jmena s identifikatorem
    __IJM                                ;...navrat puvodniho jmena
  ) ; if
) ; end defun jmelayidf

(defun layset (__JME / __JME __POM)
; funkce pro nastaveni vrstvy "__JME"
; s identifikatorem vrstev profese STAVBA
;-----------------------------------------
  (if __JME
    (progn
      (setq __JME (jmelayidf __JME))

      (command "_LAYER")
      (if (setq __POM (tblsearch "LAYER" __JME))
        (progn
          (setq __POM (cdr (assoc 70 __POM)))
          (cond
            ((or (= __POM 65) (= __POM 1)) (command "_T" __JME))
            ((or (= __POM 68) (= __POM 4)) (command "_U" __JME))
            ((or (= __POM 69) (= __POM 5)) (command "_U" __JME "_T" __JME))
          ) ; cond
        ) ; progn
      ) ; if
      (command "_M" __JME "")
    ) ; progn
  ) ; if
  (princ)
) ; end defun layset

(defun setgenroz ( / POM)
; nastaveni rozmeru generatoru 3D vyplni
;----------------------------------------

  ;...vyska parapetu okna
  (if (null L3DPOK) (setq POM 850.0) (setq POM L3DPOK))
  (initget 4)
  (setq L3DPOK (getdist (strcat "\nVka parapetu okna <" (rtos POM 2 1) ">: ")))
  (if (null L3DPOK) (setq L3DPOK POM))

  ;...vyska okna
  (if (null L3DVOK) (setq POM 1500.0) (setq POM L3DVOK))
  (initget (+ 2 4))
  (setq L3DVOK (getdist (strcat "\nVka okna <" (rtos POM 2 1) ">: ")))
  (if (null L3DVOK) (setq L3DVOK POM))

  ;...vyska parapetu dveri
  (if (null L3DPDV) (setq POM 50.0) (setq POM L3DPDV))
  (initget 4)
  (setq L3DPDV (getdist (strcat "\nVka parapetu dve <" (rtos POM 2 1) ">: ")))
  (if (null L3DPDV) (setq L3DPDV POM))

  ;...vyska dveri
  (if (null L3DVDV) (setq POM 2300.0) (setq POM L3DVDV))
  (initget (+ 2 4))
  (setq L3DVDV (getdist (strcat "\nVka dve <" (rtos POM 2 1) ">: ")))
  (if (null L3DVDV) (setq L3DVDV POM))

) ; end defun setgenroz

(defun setgenlay ( / POM)
; nastaveni vrstev generatoru 3D vyplni
;---------------------------------------

  ;...3D stena
  (if (null L3DSTE) (setq POM "3D_STENY") (setq POM L3DSTE))
  (setq L3DSTE (getstring (strcat "\n3D vrstva stn <" POM ">: ")))
  (if (= L3DSTE "") (setq L3DSTE POM))

  ;...3D vypln dveri
  (if (null L3DDVE) (setq POM "3D_DVERE") (setq POM L3DDVE))
  (setq L3DDVE (getstring (strcat "\n3D vrstva vpln dve <" POM ">: ")))
  (if (= L3DDVE "") (setq L3DDVE POM))

  ;...3D ram-zaruben dveri
  (if (null L3DZAR) (setq POM "3D_ZARUBNE") (setq POM L3DZAR))
  (setq L3DZAR (getstring (strcat "\n3D vrstva rmu-zrubn dve <" POM ">: ")))
  (if (= L3DZAR "") (setq L3DZAR POM))

  ;...3D ram-zaruben dveri
  (if (null L3DOKR) (setq POM "3D_OKNA_RAM") (setq POM L3DOKR))
  (setq L3DOKR (getstring (strcat "\n3D vrstva rm oken <" POM ">: ")))
  (if (= L3DOKR "") (setq L3DOKR POM))

  ;...3D sklo - vypln oken
  (if (null L3DOKS) (setq POM "3D_SKLO") (setq POM L3DOKS))
  (setq L3DOKS (getstring (strcat "\n3D vrstva zasklen oken <" POM ">: ")))
  (if (= L3DOKS "") (setq L3DOKS POM))

) ; end defun setgenlay

(defun uskocr (X1 X2 X3 / X1 X2 X3 XP)
; uskoceni do kvadrantu o pravouhlou vzdalenost
;-----------------------------------------------
  ; X1 - zakladni bod
  ; X2 - pravouhle posuny
  ; X3 - kvadrant

  (setq XP (sqrt (* X2 X2 2.0)))
  (cond
    ((= X3 1) (polar X1 (* PI 0.25) XP))
    ((= X3 2) (polar X1 (* PI 0.75) XP))
    ((= X3 3) (polar X1 (* PI 1.25) XP))
    ((= X3 4) (polar X1 (* PI 1.75) XP))
    (T X1)
  ) ; cond
) ; end defun uskocr

(defun ramot (R1 R2 R3 R4 R5 / R1 R2 R3 R4 R5 P1 P2 P3 P4)
; vykresleni ramu otvoru
; (ramot levy-dolni-pocatek sirka vyska tloustka-ramu sirka-ramu)
;-----------------------------------------------------------------
  ; R1 - pocatek
  ; R2 - sirka otvoru
  ; R3 - vyska otvoru
  ; R4 - tloustka ramu
  ; R5 - sirka ramu

  (command "_PLINE"
    (setq P1 R1)
    (setq P2 (polar R1 0 R2))
    (setq P3 (polar (polar R1 0 R2) (* PI 0.5) R3))
    (setq P4 (polar R1 (* PI 0.5) R3))
    "_C"
    "_EXTRUDE" (entlast) "" (- 0 R4) 0
  ) ; command
  (setq HSS0 (entlast))

  (command "_PLINE"
    (polar (polar P1 0 R5) (* PI 0.5) R5)
    (polar (polar P2 PI R5) (* PI 0.5) R5)
    (polar (polar P3 PI R5) (* PI 1.5) R5)
    (polar (polar P4 0 R5) (* PI 1.5) R5)
    "_C"
    "_EXTRUDE" (entlast) "" (- 0 R4) 0
  ) ; command
  (setq HSS1 (entlast))

  (command "_SUBTRACT" HSS0 "" HSS1 "")

) ; end defun ramot

(defun vypot (R1 R2 R3 R4 / R1 R2 R3 R4 P1 P2 P3 P4)
; vykresleni vyplne otvoru
; (vypot levy-dolni-pocatek sirka vyska tloustka)
;-------------------------------------------------
  ; R1 - pocatek
  ; R2 - sirka otvoru
  ; R3 - vyska otvoru
  ; R4 - tloustka skla

  (command "_PLINE"
    (setq P1 R1)
    (setq P2 (polar R1 0 R2))
    (setq P3 (polar (polar R1 0 R2) (* PI 0.5) R3))
    (setq P4 (polar R1 (* PI 0.5) R3))
    "_C"
    "_EXTRUDE" (entlast) "" (- 0 R4) 0
  ) ; command

) ; end defun vypot

(defun zmenz (A Z / A Z)
; zmena Z souradnice
;--------------------
  (list (car A) (cadr A) (+ (caddr A) Z))
) ; end defun zmenz

(defun c:GENVYP ( / LV BLP OSN ZSRO TLRO SLRO ZMRO ZSRD TLRD SLRD ZMRD
                    TLSK TLDV
                    UK1 UK2 UK3 PRMT PUK1 PUK2 PUK3 SST SOT
                    PUK1W PUK2W PUK3W UK1W UK2W UK3W UK1U UK2U UK3U UK4U
                    POM0 POM1 POM2 POM3 POM4 R1E R2E R3E R4E)
; generator 3D vyplni
;---------------------

  (setq BLP (getvar "BLIPMODE")  OSN (getvar "OSMODE")
        LV (getvar "CLAYER"))
  (command "_UNDO" "_G")

  ;...3D parametry otvoru
  (if (null L3DPOK) (setq L3DPOK 850.0))          ;...vyska parapetu okna
  (if (null L3DVOK) (setq L3DVOK 1500.0))         ;...vyska okna
  (if (null L3DPDV) (setq L3DPDV 50.0))           ;...vyska parapetu dveri
  (if (null L3DVDV) (setq L3DVDV 2300.0))         ;...vyska dveri

  ;...nove vrstvy 3D
  (if (null L3DSTE) (setq L3DSTE "3D_STENY"))     ;...stena
  (if (null L3DDVE) (setq L3DDVE "3D_DVERE"))     ;...vypln dveri
  (if (null L3DZAR) (setq L3DZAR "3D_ZARUBNE"))   ;...ram-zaruben dveri
  (if (null L3DOKR) (setq L3DOKR "3D_OKNA_RAM"))  ;...okenni ram
  (if (null L3DOKS) (setq L3DOKS "3D_SKLO"))      ;...sklo

  ;...rizeni vstupu
  (if (null L3DTYV) (setq L3DTYV "Okno"))         ;...typ vyplne
  (if (null L3DVST) (setq L3DVST "Pdorys"))      ;...zpusob zadani

  ;...obecne konstanty oken
  (setq ZSRO 120.0)                               ;...zasunuti ramu okna
  (setq TLRO 80.0)                                ;...tloustka ramu okna
  (setq SLRO 60.0)                                ;...sirka ramu okna
  (setq ZMRO 20.0)                                ;...zmenseni ramu okna
  ;...obecne konstanty dveri
  (setq ZSRD 120.0)                               ;...zasunuti ramu dveri
  (setq TLRD 80.0)                                ;...tloustka ramu dveri
  (setq SLRD 100.0)                               ;...sirka ramu dveri
  (setq ZMRD 20.0)                                ;...zmenseni ramu dveri
  ;...obecne konstanty vyplni
  (setq TLSK 8.0)                                 ;...tloustka zaskleni
  (setq TLDV 35.0)                                ;...tloustka vyplne

  ;...definice vrstev 3D
  (if (not (tblsearch "LAYER" L3DSTE))
    (command "_LAYER" "_N" L3DSTE "_C" 3 L3DSTE "")
  ) ; if
  (if (not (tblsearch "LAYER" L3DDVE))
    (command "_LAYER" "_N" L3DDVE "_C" 9 L3DDVE "")
  ) ; if
  (if (not (tblsearch "LAYER" L3DZAR))
    (command "_LAYER" "_N" L3DZAR "_C" 141 L3DZAR "")
  ) ; if
  (if (not (tblsearch "LAYER" L3DOKR))
    (command "_LAYER" "_N" L3DOKR "_C" 53 L3DOKR "")
  ) ; if
  (if (not (tblsearch "LAYER" L3DOKS))
    (command "_LAYER" "_N" L3DOKS "_C" 141 L3DOKS "")
  ) ; if

  (setq UK1 "Hladiny")
  (while (or (= UK1 "Hladiny") (= UK1 "Rozmry")
             (= UK1 "Vpl") (= UK1 "Pdorys") (= UK1 "Model")
         ) ; or

    (if (= L3DVST "Pdorys")
      (setq PRMT "/Model/<- zadn z PDORYSU - lev vnj roh otvoru v pdorysu -")
      (setq PRMT "/Pdorys/<- zadn ve 3D - lev doln roh 3D otvoru -")
    ) ; if

    (initget 1 "Hladiny Rozmry Vpl Pdorys Model")
    (setq UK1
      (getpoint (strcat "\nHladiny/Rozmry/Vpl-" L3DTYV PRMT ">: "))
    ) ; setq

    (cond
      ((= UK1 "Hladiny") (setgenlay))
      ((= UK1 "Rozmry") (setgenroz))
      ((= UK1 "Vpl")
        (progn
          (if (= L3DTYV "Okno") (setq L3DTYV "Dvee") (setq L3DTYV "Okno"))
          (princ (strcat "\n*** Pepnuto na " L3DTYV "."))
        ) ; progn
      ) ; cond-cond
      ((= UK1 "Pdorys")
        (progn
          (setq L3DVST "Pdorys")
          (princ "\n*** Pepnuto na Pdorys.")
        ) ; progn
      ) ; cond-cond
      ((= UK1 "Model")
        (progn
          (setq L3DVST "Model")
          (princ "\n*** Pepnuto na Model.")
        ) ; progn
      ) ; cond-cond
      (T
        (cond
          ((= L3DVST "Pdorys")
            (setq
                  PUK1 UK1
                  PUK2 (getpoint PUK1 "\nPrav vnj roh otvoru v pdorysu: ")
                  PUK3 (getpoint PUK1 "\nLev vnitn roh otvoru v pdorysu: ")
            ) ; setq
          ) ; cond-cond
          ((= L3DVST "Model")
            (setq
                  UK2 (getpoint UK1 "\nPrav doln roh 3D otvoru: ")
                  UK3 (getpoint UK1 "\nLev horn roh 3D otvoru: ")
            ) ; setq
          ) ; cond-cond
        ) ; cond
      ) ; cond-cond
    ) ; cond

  ) ; while

  (if (= L3DVST "Pdorys")
    (progn
      (setq
            SST (distance PUK1 PUK3)   ;...sirka steny
      ) ; setq
      (setq
            PUK1W (trans PUK1 1 0)     ;...prevod pudorysu do GSS
            PUK2W (trans PUK2 1 0)
            PUK3W (trans PUK3 1 0)

            POM0 (if (= L3DTYV "Okno") L3DPOK L3DPDV)
            UK1W (list (car PUK1W) (cadr PUK1W) (+ (caddr PUK1W) POM0))
            UK2W (list (car PUK2W) (cadr PUK2W) (+ (caddr PUK2W) POM0))

            POM1 (if (= L3DTYV "Okno") L3DVOK L3DVDV)
            UK3W (list (car PUK1W) (cadr PUK1W) (+ (caddr PUK1W) POM0 POM1))

            UK1 (trans UK1W 0 1)       ;...uzivatelske souradnice 3D
            UK2 (trans UK2W 0 1)
            UK3 (trans UK3W 0 1)
      ) ; setq
    ) ; progn
    (setq
          UK1W (trans UK1 1 0)         ;...prevod 3D do GSS
          UK2W (trans UK2 1 0)
          UK3W (trans UK3 1 0)
    ) ; setq
  ) ; if

  (setvar "BLIPMODE" 0) (setvar "OSMODE" 0)

  (command "_UCS" "3" UK1 UK2 UK3)
  (setq UK1U (trans UK1W 0 1)          ;...prevod do uzivatelskych souradnic
        UK2U (trans UK2W 0 1)
        UK3U (trans UK3W 0 1))

  (setq SOT (distance UK1U UK2U))      ;...sirka otvoru

  ;...ctvrty bod otvoru
  (setq UK4U (polar UK3U (angle UK1U UK2U) SOT))

  (if (= L3DVST "Pdorys")
    (progn
      ;...vykresleni telesa ve stene
      (layset L3DSTE)
      (command "_PLINE" UK1U UK2U UK4U UK3U "_C"
               "_EXTRUDE" (entlast) "" (- SST) 0
      ) ; command
    ) ; progn
  ) ; if

  (if (= L3DTYV "Okno")
      (setq POM1 ZSRO  POM2 TLRO  POM3 SLRO  POM4 ZMRO)
      (setq POM1 ZSRD  POM2 TLRD  POM3 SLRD  POM4 ZMRD)
  ) ; if

  ;...vnejsi obrys ramu
  (setq R1E (zmenz UK1U (- 0.0 POM1))
        R2E (zmenz UK2U (- 0.0 POM1))
        R3E (zmenz UK3U (- 0.0 POM1))
        R4E (zmenz UK4U (- 0.0 POM1)))

  ;...vykresleni hlavniho ramu
  (if (= L3DTYV "Okno") (layset L3DOKR) (layset L3DZAR))
  ; (ramot levy-dolni-pocatek sirka vyska tloustka-ramu sirka-ramu)
  ;-----------------------------------------------------------------
  (ramot R1E (distance R1E R2E) (distance R1E R3E) POM2 POM3)

  ;...vnitrni ram
  (if (= L3DTYV "Okno") (layset L3DOKR) (layset L3DZAR))
  ; (ramot levy-dolni-pocatek sirka vyska tloustka-ramu sirka-ramu)
  ;-----------------------------------------------------------------
  (ramot (zmenz (uskocr R1E POM3 1)
           (- 0.0 (/ POM4 2.0))
         ) ; zmenz
         (- (distance R1E R2E) POM3 POM3)
         (- (distance R1E R3E) POM3 POM3)
         (- POM2 POM4) (- POM3 POM4)
  ) ; ramot

  ;...vypln vnitrniho ramu z dvojice ramu
  (if (= L3DTYV "Okno") (layset L3DOKS) (layset L3DDVE))
  ; (vypot levy-dolni-pocatek sirka vyska tloustka)
  ;-------------------------------------------------
  (vypot (zmenz (uskocr (uskocr R1E POM3 1) (- POM3 POM4) 1)
           (- 0.0 POM4)
         ) ; zmenz
         (+ (- (distance R1E R2E) (* POM3 4.0)) POM4 POM4)
         (+ (- (distance R1E R3E) (* POM3 4.0)) POM4 POM4)
         (if (= L3DTYV "Okno") TLSK TLDV)
  ) ; vypot

  (command "_UCS" "_P")
  (lalaset LV) (setvar "BLIPMODE" BLP) (setvar "OSMODE" OSN)
  (command "_UNDO" "_E")

  (princ)

) ; end defun c:GENVYP

(princ "nateno.")
(princ "\nSJ-3D v.18.0, (C) Skipy Jones, AC9-14LSP [cs], 2018.")
(princ)
(princ "\nKopie pro:  30-ti denn demonstran kopie.")
(princ)
